﻿package 
{
	import Layer;
	import flash.display.Bitmap;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.filters.BitmapFilterQuality;
	
	
	public class Main extends MovieClip
	{
		
		
		private const STAGEWIDTH:Number= 800;
		private const STAGEHEIGHT:Number = 600;
		
		private var _layers:Array;
		
		private var MIDDLE:Number = 20;
		private var debug_txt:TextField;
		
		private var blurFilter:BlurFilter;
		
		public function Main():void
		{

			_layers = new Array();
			
			
			//load xml
			var xmlRequest:URLRequest = new URLRequest("data.xml");
			var xmlLoader:URLLoader = new URLLoader(xmlRequest);
			xmlLoader.addEventListener(Event.COMPLETE, onXMLLoaded);
			
			this.addEventListener(Event.ENTER_FRAME, move);
			
			
			
			
		}
		
		private function onXMLLoaded(e:Event):void {
			var xmlData:XML = new XML(e.target.data);
			
			//loop through all the layers...
			var layers:XMLList = xmlData.layers;
			
			for (var i:int = layers.child("*").length()-1; i >=0 ; i--) {
				var layer:Layer = new Layer(layers.children()[i].@image);
				debug(layers.children()[i].@image);
				layer.speed = Number(layers.children()[i].@speed);
				this.addChild(layer);
				layer.y = Number(layers.children()[i].@y);
				_layers.push(layer);
			}
			
		
			
			
		
		}
		
		private function debug(text:String):void {
			debug_txt.text = text;
			
		}
		
		public function move(e:Event):void {
			
			var direction:Number = 0;
			if (this.mouseX > STAGEWIDTH / 2 -  MIDDLE/2&&this.mouseX < STAGEWIDTH / 2 +  MIDDLE/2) {
				//no move
			}else if (this.mouseX < STAGEWIDTH / 2) {
				direction = -1;
				
			}else if (this.mouseX > STAGEWIDTH / 2) {
				direction = 1;
			}
			var speedOffset:Number = Math.abs(this.mouseX - (STAGEWIDTH / 2));
			
			var percent:Number = speedOffset/(STAGEWIDTH / 2);
			debug("" + percent);
			
			
			
			for (var i:Number = 0; i < _layers.length; i++) {
				//move each layer..
				var layer:Layer = _layers[i];
				layer.x += direction * (layer.speed * percent);
								
				if (layer.x <= 0 - layer.imageWidth) {
					layer.x = 0;
				}else if (layer.x >= 0) {
					layer.x = 0-layer.imageWidth;
				}
				
				
				
				var array_filter:Array=new Array();
				var filter:BlurFilter=new BlurFilter(layer.speed * percent,0,	1);
				array_filter.push(filter);
				layer.filters=array_filter;
				
				
			}
			
		}
		
		
	}
}